﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.ComponentModel;

using Infragistics.Silverlight.Controls.Primitives;
using Infragistics.Silverlight;
using System.Windows.Media.Imaging;

namespace TimeSelector
{
    public partial class MainPage : UserControl,INotifyPropertyChanged
    {
        public MainPage()
        {
            InitializeComponent(); 
        }

        private void SearchResults_Drop(object sender, Infragistics.Silverlight.DropEventArgs e)
        {
            MessageBox.Show("from" + this.slider.Thumbs[0].Value.ToString() + " to " + this.slider.Thumbs[1].Value.ToString());
        }

        private double sliderHeight = 150;
        public double SliderHeight 
        {
            get
            {
                return sliderHeight;
            }

            set
            {
                sliderHeight = value;
                NotifyPropertyChanged("SliderHeight"); 
            }

        }

        private List<string> selectedCaptions = new List<string>();
        public List<string> SelectedCaptions
        {
            get
            {
                return selectedCaptions;
            }
            set
            {
                selectedCaptions = value;
                NotifyPropertyChanged("SelectedCaptions");
            }
        }



        public double TrackFillHeight{ get; set; }

        private double imageheight = 150;
        public double ImageHeight 
        {
            get { return imageheight; }
            set
            {
                imageheight = value;
                SliderHeight = value + 19;
                TrackFillHeight = value - 6;
                NotifyPropertyChanged("ImageHeight"); 
            }
        }


        public event PropertyChangedEventHandler PropertyChanged;

        private void NotifyPropertyChanged(string propertyName)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
            }
        }

        private void DragSource_DragStart(object sender, Infragistics.Silverlight.DragDropStartEventArgs e)
        {
            //ListBox box = new ListBox();
            //ListBoxItem l1 = new ListBoxItem();
            //l1.Content = "some text1 ";
            //box.Items.Add(l1);
            //box.Height = 100;
            //box.Width = 100;

            //TextBox box = new TextBox();
            //box.Text = "yahooo";
            //e.DragSnapshotElement = box;
        }


        bool islatestPeriod = false;
        bool isStartingPeriod = false;
        private void cmbAddOptions_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            if (cmbAddOptions != null)
            {
                if (cmbAddOptions.SelectedIndex == 1)
                {
                    slider.Thumbs[1].Value = slider.MaxValue;
                    slider.Thumbs[0].Value = slider.MaxValue - 1;
                    islatestPeriod = true;
                    isStartingPeriod = false;
                    slider.Thumbs[1].IsDragEnabled = false;
                    slider.TrackClickAction = SliderTrackClickAction.None;
                    slider.IsSelectionRangeEnabled = false;
                }
                else if (cmbAddOptions.SelectedIndex == 2)
                {
                    isStartingPeriod = true;
                    islatestPeriod = false;

                    slider.TrackClickAction = SliderTrackClickAction.None;
                    slider.IsSelectionRangeEnabled = true;
                    slider.Thumbs[0].IsTrackFillVisible = false;
                    slider.Thumbs[0].IsDragEnabled = true;
                    /***********************************************/
                    //In the above line setting the DragEnabled of THumb[0] renders the the trackfill all the way till the 
                    //left end of the slider.
                    /***********************************************/
                    slider.Thumbs[1].IsDragEnabled = false;
                   
                }
                else
                {
                    isStartingPeriod = false;
                    islatestPeriod = false;              
                    slider.IsSelectionRangeEnabled = true;
                    slider.Thumbs[0].IsDragEnabled = true;
                    slider.Thumbs[1].IsDragEnabled = true;
                    slider.TrackClickAction = SliderTrackClickAction.None;
                }
            }
        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {

        }

        private void leftThumb_DragCompleted(object sender, System.Windows.Controls.Primitives.DragCompletedEventArgs e)
        {

        }
    }
}
